diff --git a/src/abg-ctf-reader.cc b/src/abg-ctf-reader.cc
index e5ea0ca2..ec6a5c81 100644
--- a/src/abg-ctf-reader.cc
+++ b/src/abg-ctf-reader.cc
@@ -384,6 +384,53 @@ process_ctf_sou_members(read_context *ctxt,
     fprintf(stderr, "ERROR from ctf_member_next\n");
 }
 
+static type_base_sptr
+process_ctf_forward_type(read_context *ctxt,
+                         corpus_sptr corp,
+                         translation_unit_sptr tunit,
+                         ctf_dict_t *ctf_dictionary,
+                         ctf_id_t ctf_type)
+{
+  decl_base_sptr result;
+  std::string type_name = ctf_type_name_raw(ctf_dictionary,
+                                            ctf_type);
+  bool type_is_anonymous = (type_name == "");
+  uint32_t kind = ctf_type_kind_forwarded (ctf_dictionary, ctf_type);
+
+  if (kind == CTF_K_UNION)
+    {
+      union_decl_sptr
+       union_fwd(new union_decl(ctxt->ir_env,
+                                type_name,
+                                /*alignment=*/0,
+                                location(),
+                                decl_base::VISIBILITY_DEFAULT,
+                                type_is_anonymous));
+      union_fwd->set_is_declaration_only(true);
+      result = union_fwd;
+    }
+  else
+    {
+      class_decl_sptr
+       struct_fwd(new class_decl(ctxt->ir_env, type_name,
+                                 /*alignment=*/0, /*size=*/0,
+                                 true /* is_struct */,
+                                 location(),
+                                 decl_base::VISIBILITY_DEFAULT,
+                                 type_is_anonymous));
+      struct_fwd->set_is_declaration_only(true);
+      result = struct_fwd;
+    }
+
+  if (!result)
+    return is_type(result);
+
+  add_decl_to_scope(result, tunit->get_global_scope());
+  ctxt->add_type(ctf_type, is_type(result));
+
+  return is_type(result);
+}
+
 /// Build and return a struct type libabigail IR.
 ///
 /// @param ctxt the read context.
@@ -813,6 +860,12 @@ process_ctf_type(read_context *ctxt,
         result = is_type(struct_decl);
         break;
       }
+    case CTF_K_FORWARD:
+      {
+        result = process_ctf_forward_type(ctxt, corp, tunit, ctf_dictionary,
+                                          ctf_type);
+      }
+      break;
     case CTF_K_UNION:
       {
         union_decl_sptr union_decl
diff --git a/tests/data/Makefile.am b/tests/data/Makefile.am
index a7eb7ff0..8f71fcbf 100644
--- a/tests/data/Makefile.am
+++ b/tests/data/Makefile.am
@@ -660,6 +660,9 @@ test-read-ctf/test-functions-declaration.o	\
 test-read-ctf/test-forward-type-decl.abi	\
 test-read-ctf/test-forward-type-decl.o	\
 test-read-ctf/test-forward-type-decl.c	\
+test-read-ctf/test-forward-undefine-type-decl.abi	\
+test-read-ctf/test-forward-undefine-type-decl.c		\
+test-read-ctf/test-forward-undefine-type-decl.o		\
 test-read-ctf/test-list-struct.c	\
 test-read-ctf/test-list-struct.o	\
 test-read-ctf/test-list-struct.abi	\
diff --git a/tests/data/test-read-ctf/test-forward-undefine-type-decl.abi b/tests/data/test-read-ctf/test-forward-undefine-type-decl.abi
new file mode 100644
index 00000000..ff019208
--- /dev/null
+++ b/tests/data/test-read-ctf/test-forward-undefine-type-decl.abi
@@ -0,0 +1,31 @@
+<abi-corpus version='2.1' path='data/test-read-ctf/test-forward-undefine-type-decl.o'>
+  <elf-variable-symbols>
+    <elf-symbol name='k' size='24' type='object-type' binding='global-binding' visibility='default-visibility' is-defined='yes'/>
+  </elf-variable-symbols>
+  <abi-instr address-size='64' language='LANG_C'>
+    <class-decl name='key_restriction' size-in-bits='192' alignment-in-bits='64' is-struct='yes' visibility='default' id='type-id-1'>
+      <data-member access='public' layout-offset-in-bits='0'>
+        <var-decl name='check' type-id='type-id-2' visibility='default'/>
+      </data-member>
+      <data-member access='public' layout-offset-in-bits='64'>
+        <var-decl name='keytype' type-id='type-id-3' visibility='default'/>
+      </data-member>
+      <data-member access='public' layout-offset-in-bits='128'>
+        <var-decl name='keyutype' type-id='type-id-4' visibility='default'/>
+      </data-member>
+    </class-decl>
+    <typedef-decl name='key_restrict_link_func_t' type-id='type-id-5' id='type-id-2'/>
+    <pointer-type-def type-id='type-id-6' size-in-bits='64' alignment-in-bits='64' id='type-id-3'/>
+    <pointer-type-def type-id='type-id-7' size-in-bits='64' alignment-in-bits='64' id='type-id-4'/>
+    <pointer-type-def type-id='type-id-8' size-in-bits='64' alignment-in-bits='64' id='type-id-5'/>
+    <class-decl name='key_type' is-struct='yes' visibility='default' is-declaration-only='yes' id='type-id-6'/>
+    <var-decl name='k' type-id='type-id-1' mangled-name='k' visibility='default'/>
+    <function-type size-in-bits='64' alignment-in-bits='8' id='type-id-8'>
+      <parameter type-id='type-id-3'/>
+      <parameter type-id='type-id-4'/>
+      <return type-id='type-id-9'/>
+    </function-type>
+    <union-decl name='key_utype' visibility='default' is-declaration-only='yes' id='type-id-7'/>
+    <type-decl name='void' id='type-id-9'/>
+  </abi-instr>
+</abi-corpus>
diff --git a/tests/data/test-read-ctf/test-forward-undefine-type-decl.c b/tests/data/test-read-ctf/test-forward-undefine-type-decl.c
new file mode 100644
index 00000000..b6ab4896
--- /dev/null
+++ b/tests/data/test-read-ctf/test-forward-undefine-type-decl.c
@@ -0,0 +1,17 @@
+/* Test undefined forward declarations
+ * gcc -gctf -c test-forward-undefine-type-decl.c -o \
+ *    test-forward-undefine-type-decl.o
+ */
+
+struct key_type;
+union  key_utype;
+typedef void (*key_restrict_link_func_t)(struct key_type *type,
+                                         union key_utype *utype);
+
+struct key_restriction {
+ key_restrict_link_func_t check;
+ struct key_type *keytype;
+ union key_utype *keyutype;
+};
+
+struct key_restriction k;
diff --git a/tests/data/test-read-ctf/test-forward-undefine-type-decl.o b/tests/data/test-read-ctf/test-forward-undefine-type-decl.o
new file mode 100644
index 0000000000000000000000000000000000000000..e8adc1441c5142cd085cf4cc18356bb521ec137c
GIT binary patch
diff --git a/tests/test-read-ctf.cc b/tests/test-read-ctf.cc
index e7a87186..8ed8ac1a 100644
--- a/tests/test-read-ctf.cc
+++ b/tests/test-read-ctf.cc
@@ -268,6 +268,14 @@ static InOutSpec in_out_specs[] =
     "data/test-read-ctf/test-callback2.abi",
     "output/test-read-ctf/test-callback2.abi",
   },
+  {
+    "data/test-read-ctf/test-forward-undefine-type-decl.o",
+    "",
+    "",
+    SEQUENCE_TYPE_ID_STYLE,
+    "data/test-read-ctf/test-forward-undefine-type-decl.abi",
+    "output/test-read-ctf/test-forward-undefine-type-decl.abi",
+  },
   // This should be the last entry.
   {NULL, NULL, NULL, SEQUENCE_TYPE_ID_STYLE, NULL, NULL}
 };